// Native
const path = require('path')

// Packages
const findParentDir = require('find-parent-dir')

module.exports = (name, options = {}) => new Promise((resolve, reject) => {
  const executable = options.executable || name
  const paths = options.paths || null

  let mod

  try {
    mod = require.resolve(name, paths ? { paths } : {})
  } catch (err) {
    reject(err)
    return
  }

  findParentDir(mod, 'package.json', (err, dir) => {
    if (err) {
      reject(err)
      return
    }

    const pack = require(path.join(dir, 'package.json'))
    const binfield = pack.bin

    const binpath = typeof binfield === 'object' ? binfield[executable] : binfield

    if (!binpath) {
      reject(new Error("No bin `" + executable + "` in module `" + name + "`"))
    }

    resolve(path.join(dir, binpath))
  })
})
